#ifndef	_APLIB_H
#	define	_APLIB_H
#ifndef	_MOSSLIB_H
#include	"mosslib.h"
#endif

// Active Page based simulator lib.

class	ActivePage;
class	ActivePageMemorySystem
	{
	public:
		ActivePage	*APList;
				int				isLocked;
				int				qsec;
				int				APMultiplexer;
				int				APStart;
					ActivePageMemorySystem();
					~ActivePageMemorySystem();
			int	SimulateFor(int	usec);
				int	Add(ActivePage	*);
				int	Remove(ActivePage *);
	};

class	ActivePage
	{
	public:
				ActivePage		*Next;
				void			*RawPage;
				int				IsActive;
	volatile	int				IsNowActive;
		static	int				VLIWWidth;
	public:
				ActivePage()
				{ Next = NULL; RawPage = NULL; IsActive = 0; IsNowActive = 0; }
		virtual	int		SimulateFor(int	usec);
	};

extern	ActivePageMemorySystem	*APMS;
int	APLibStart();
int	APLibEnd();
#endif

int	apmain(int, char *[]);
